""" ZSS Attribute """
__version__='3.1'

from Globals import HTMLFile, MessageDialog
from OFS import SimpleItem
from OFS import ObjectManager
from OFS import PropertyManager
import string

import BrowserType
 
def manage_addZSSAttrForm(self, REQUEST):
    """ Add a ZSSAttr object """
    strret = "<html><head><title>Add Z Style Sheet Attribute</title></head>"
    strret = strret + '<body><h1 align=center>Add Z Style Sheet Attibute</h1><form action="manage_addZSSAttr" method="POST">'
    strret = strret + '<div align=center><center><table cellspacing="2">'
    strret = strret + '<tr><th align="LEFT" valign="TOP">Id</th><td align="LEFT" valign="TOP"><input type="TEXT" name="id" size="20"></td></tr>'
    strret = strret + '<tr><th align="LEFT" valign="TOP">Value</th><td align="LEFT" valign="TOP"><input type="TEXT" name="value" size="20"></td></tr>'
    strret = strret + '<tr><th align="LEFT" valign="TOP">Browsers</th><td align="LEFT" valign="TOP"><select name="Browsers" size="3" multiple>'
    for i in BrowserType.ListBrowsers():
        strret = strret + '<option selected name="%s">%s</option>' % (i, i)
    strret = strret + '</select></td></tr><tr><td></td><td>'
    strret = strret + '<input type="SUBMIT" value="Add"></td></tr>'
    strret = strret + '</table></center></div></form></body></html>'
    return strret

def manage_addZSSAttr(self, id, value='', Browsers=[], REQUEST=None):
    """ Add a ZSSAttr object """
    self._setObject(id, ZSSAttr(id, value, Browsers, REQUEST))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class ZSSAttr(	PropertyManager.PropertyManager,
                SimpleItem.SimpleItem,
                BrowserType.BrowserType):
    """Representation of Cascading Style Sheet Attributes."""
    manage_propertiesForm=HTMLFile('properties', globals())
    manage=manage_main=manage_workspace=manage_propertiesForm

    meta_type    = 'ZSS Attribute'
    id        = 'ZSSAttr'
    icon        = 'misc_/ZStyleSheet/ZSSAttr'
    manage_options    = (
            {'label': 'Properties', 'action': 'manage_main'},
            {'label': 'Preview', 'action': 'index_html'},
            {'label': 'Undo', 'action': 'manage_UndoForm'},
            )
    __ac_permissions__= (
            ('Manage properties',
                ('manage_addProperty',
                'manage_editProperties',
                'manage_delProperties',
                'manage_changeProperties',
                )
            ),
            ('Access contents information',
                ('hasProperty',
                'propertyIds',
                'propertyValues',
                'propertyItems',
                '',
                ),
                ('Anonymous', 'Manager'),
                        ),
            )
    _properties=(
        {'id' : 'value', 'type': 'string', 'mode': 'w'},
        {'id' : 'Browsers', 'type' : 'multiple selection', 'mode': 'w', 'select_variable': 'BrowserList'},
        )

    def __init__(self, id, value='', Browsers=[], REQUEST=None):
        """Initialise a ZSSAttr"""
        self.id=id
        self.value=value
        if (not(Browsers)):
            Browsers=self.BrowserList()
        self.Browsers=Browsers

    def dump(self, REQUEST):
        """ Dump this rule, showing the browser restrictions
            in comments. """
        return "/* Browsers=%s */\n\t%s: %s;" % (self.Browsers, self.id, self.value)

    def __str__(self, REQUEST):
        """ Render this attribute """
        b=""
        for i in self.Browsers:
            if (self.isBrowser(i, REQUEST)!=0):
                b=i
        if (b==""):
            return "/* %s - Excluded for this browser */" % self.id
        else:
            return "%s: %s; " % (self.id, self.value)

    def index_html(self, REQUEST):
        """ """
        return self.__str__(REQUEST)

    def tag(self, REQUEST):
        """ """
        return self.__str__(REQUEST)
